#include <hidef.h>      /* common defines and macros */
#include <mc9s12c128.h>     /* derivative information */
#pragma LINK_INFO DERIVATIVE "mc9s12c32"


/* 
  Carnegie Mellon 18-348   simple test program for lab module
  
  Compile and run -- lab module will alternately blink LED1 through LED4

  This program uses pins 4-7 of Port B for outputs as they are connected
  to LEDs 1-4.

*/
void main(void) {
  
  long unsigned int i;
  
  EnableInterrupts;
  
  /*
    NOTE:            
    Writing a 0 to bit y of DDRx sets bit y of Port x to input.
    Writing a 1 to bit y of DDRx sets bit y of Port x to output.
  */

  /* set port B to output */
  DDRB_BIT4 = 1;
  DDRB_BIT5 = 1;
  DDRB_BIT6 = 1;
  DDRB_BIT7 = 1;

  /* set port P to input */
  DDRP = 0x00;
  /*enable pullups on pin 0 and 1 of port P*/
  PERP_PERP1 = 1;
  PERP_PERP0 = 1;         
  
  /* 
    NOTE:
    LEDs on CSM12C128 board are inverted (e.g. putting a 1 or high value
    causes the LED to be off while putting a 0 or low value causes the
    LED to be on.
  */
 
  /* loop forever */
  for(;;) {
      /* Turn on LED1 */
   for(i = 0; i < 20000; i++)
   { 
      if (PTP_PTP0 == 0) PORTB = 0x00;
      else if (PTP_PTP1 == 0) PORTB = 0xF0;
      else PORTB = 0x10 ^ 0xF0; 
   }

      /* Turn on LED2 */
   for(i = 0; i < 20000; i++)
   { 
      if (PTP_PTP0 == 0) PORTB = 0x00;
      else if (PTP_PTP1 == 0) PORTB = 0xF0;
      else PORTB = 0x20 ^ 0xF0; 
   }
      /* Turn on LED3 */
   for(i = 0; i < 20000; i++)
   { 
      if (PTP_PTP0 == 0) PORTB = 0x00;
      else if (PTP_PTP1 == 0) PORTB = 0xF0;
      else PORTB = 0x40 ^ 0xF0; 
   }
      /* Turn on LED4 */
   for(i = 0; i < 20000; i++)
   { 
      if (PTP_PTP0 == 0) PORTB = 0x00;
      else if (PTP_PTP1 == 0) PORTB = 0xF0;
      else PORTB = 0x80 ^ 0xF0; 
   }
  
  } 
  
  /* please make sure that you never leave this function */
}
